function SciMLBase.isautodifferentiable(alg::FunctionMap)
    true
end
function SciMLBase.allows_arbitrary_number_types(alg::FunctionMap)
    true
end
function SciMLBase.allowscomplex(alg::FunctionMap)
    true
end

SciMLBase.isdiscrete(alg::FunctionMap) = true

isfsal(alg::FunctionMap) = false

alg_order(alg::FunctionMap) = 0

beta2_default(alg::FunctionMap) = 0

beta1_default(alg::FunctionMap, beta2) = 0

function FunctionMap_scale_by_time(alg::FunctionMap{scale_by_time}) where {scale_by_time}
    scale_by_time
end

dt_required(alg::FunctionMap) = false
isdiscretealg(alg::FunctionMap) = true

function _ode_addsteps!(
        k, t, uprev, u, dt, f, p, cache::FunctionMapCache,
        always_calc_begin = false, allow_calc_end = true,
        force_calc_end = false
    )
    return nothing
end

function _ode_addsteps!(
        k, t, uprev, u, dt, f, p, cache::FunctionMapConstantCache,
        always_calc_begin = false, allow_calc_end = true,
        force_calc_end = false
    )
    return nothing
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{FunctionMapConstantCache, FunctionMapCache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars::Nothing
    )
    y₀
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{FunctionMapConstantCache, FunctionMapCache},
        idxs, T::Type{Val{0}}, differential_vars::Nothing
    )
    y₀[idxs]
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{FunctionMapConstantCache, FunctionMapCache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars::Nothing
    )
    recursivecopy!(out, y₀)
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{FunctionMapConstantCache, FunctionMapCache},
        idxs, T::Type{Val{0}}, differential_vars::Nothing
    )
    @views out[idxs] .= y₀[idxs]
end

using OrdinaryDiffEqFunctionMap
using Aqua

@testset "Aqua" begin
    Aqua.test_all(
        OrdinaryDiffEqFunctionMap;
        piracies = false  # Piracy is necessary for default algorithm dispatch
    )
end

import OrdinaryDiffEqFunctionMap
import OrdinaryDiffEqCore
using Test
using SciMLBase
using SciMLBase: solve, init, DiscreteProblem

const FunctionMap = OrdinaryDiffEqFunctionMap.FunctionMap

# Helper functions to check algorithm properties regardless of module context
is_functionmap(alg) = typeof(alg).name.name == :FunctionMap
function get_scale_by_time(alg)
    # Access the type parameter directly since it's FunctionMap{scale_by_time}
    T = typeof(alg)
    # The parameter is stored as a type parameter
    return T.parameters[1]
end

@testset "DiscreteProblem Default Algorithm" begin
    # Test scalar DiscreteProblem
    f(u, p, t) = 1.01 * u
    prob_scalar = DiscreteProblem(f, 0.5, (0.0, 1.0))
    
    @testset "Scalar DiscreteProblem" begin
        # Test solve without explicit algorithm
        sol = solve(prob_scalar)
        @test is_functionmap(sol.alg)
        @test get_scale_by_time(sol.alg) == false
        @test length(sol.u) > 1
        
        # Test init without explicit algorithm
        integrator = init(prob_scalar)
        @test is_functionmap(integrator.alg)
        @test get_scale_by_time(integrator.alg) == false
    end
    
    # Test array DiscreteProblem
    function f_array!(du, u, p, t)
        du[1] = 1.01 * u[1]
        du[2] = 0.99 * u[2]
    end
    prob_array = DiscreteProblem(f_array!, [0.5, 1.0], (0.0, 1.0))
    
    @testset "Array DiscreteProblem" begin
        # Test solve without explicit algorithm
        sol = solve(prob_array)
        @test is_functionmap(sol.alg)
        @test get_scale_by_time(sol.alg) == false
        @test length(sol.u) > 1
        
        # Test init without explicit algorithm
        integrator = init(prob_array)
        @test is_functionmap(integrator.alg)
        @test get_scale_by_time(integrator.alg) == false
    end
    
    # Test that explicit algorithm specification still works
    @testset "Explicit FunctionMap specification" begin
        sol1 = solve(prob_scalar, FunctionMap())
        @test is_functionmap(sol1.alg)
        @test get_scale_by_time(sol1.alg) == false
        
        sol2 = solve(prob_scalar, FunctionMap(scale_by_time=true), dt=0.1)
        @test is_functionmap(sol2.alg)
        @test get_scale_by_time(sol2.alg) == true
        
        integrator1 = init(prob_scalar, FunctionMap())
        @test is_functionmap(integrator1.alg)
        @test get_scale_by_time(integrator1.alg) == false
        
        integrator2 = init(prob_scalar, FunctionMap(scale_by_time=true), dt=0.1)
        @test is_functionmap(integrator2.alg)
        @test get_scale_by_time(integrator2.alg) == true
    end
    
    # Test that the default behaves correctly with different problem types
    @testset "DiscreteProblem with integer time" begin
        henon_map!(u_next, u, p, t) = begin
            u_next[1] = 1 + u[2] - 1.4 * u[1]^2
            u_next[2] = 0.3 * u[1]
        end
        
        prob_int = DiscreteProblem(henon_map!, [0.5, 0.5], (0, 10))
        
        sol = solve(prob_int)
        @test is_functionmap(sol.alg)
        @test eltype(sol.t) <: Integer
        
        integrator = init(prob_int)
        @test is_functionmap(integrator.alg)
    end
end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {
        cacheType <:
        FunctionMapConstantCache,
    }
    return "left-endpoint piecewise constant"
end
function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {cacheType <: FunctionMapCache}
    return "left-endpoint piecewise constant"
end

using Pkg
Pkg.add("JET")

import OrdinaryDiffEqFunctionMap
using JET

@testset "JET Tests" begin
    test_package(
        OrdinaryDiffEqFunctionMap, target_modules = (OrdinaryDiffEqFunctionMap,), mode = :typo
    )
end

@cache struct FunctionMapCache{uType, rateType} <: OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    tmp::rateType
end
get_fsalfirstlast(cache::FunctionMapCache, u) = (nothing, nothing)

function alg_cache(
        alg::FunctionMap, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return FunctionMapCache(
        u, uprev,
        FunctionMap_scale_by_time(alg) ? rate_prototype :
            (eltype(u) <: Enum ? copy(u) : zero(u))
    )
end

struct FunctionMapConstantCache <: OrdinaryDiffEqConstantCache end

function alg_cache(
        alg::FunctionMap, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return FunctionMapConstantCache()
end

isdiscretecache(cache::Union{FunctionMapCache, FunctionMapConstantCache}) = true

@doc raw"""
    FunctionMap(; scale_by_time = false)

A fixed timestep method for when the ODE is a discrete dynamical system. In the 
operator setting, this is equivalent to operator splitting for additive operators.

When `scale_by_time = true`, the method becomes `u_{n+1} = u_n + dt*f(u_n,p,t_n)`, 
otherwise it's `u_{n+1} = f(u_n,p,t_n)`.

!!! note
    This method requires a fixed timestep dt and is not adaptive.
"""
struct FunctionMap{scale_by_time} <: OrdinaryDiffEqAlgorithm end
FunctionMap(; scale_by_time = false) = FunctionMap{scale_by_time}()

module OrdinaryDiffEqFunctionMap

import OrdinaryDiffEqCore: isfsal, beta2_default, beta1_default, OrdinaryDiffEqAlgorithm,
    initialize!, perform_step!, unwrap_alg,
    OrdinaryDiffEqMutableCache,
    alg_cache, @cache, _ode_addsteps!, _ode_interpolant!,
    _ode_interpolant, get_fsalfirstlast,
    alg_order, OrdinaryDiffEqConstantCache, dt_required,
    isdiscretecache, isdiscretealg, full_cache
using DiffEqBase
import RecursiveArrayTools: recursivecopy!
import FastBroadcast: @..
import MuladdMacro: @muladd
import Static: False
import OrdinaryDiffEqCore

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("functionmap_caches.jl")
include("interp_func.jl")
include("interpolants.jl")
include("functionmap_perform_step.jl")
include("fixed_timestep_perform_step.jl")

# Default algorithm for DiscreteProblem
function SciMLBase.__solve(
        prob::SciMLBase.DiscreteProblem, ::Nothing, args...;
        kwargs...
    )
    return SciMLBase.__solve(prob, FunctionMap(), args...; kwargs...)
end

function SciMLBase.__init(
        prob::SciMLBase.DiscreteProblem, ::Nothing, args...;
        kwargs...
    )
    return SciMLBase.__init(prob, FunctionMap(), args...; kwargs...)
end

export FunctionMap

end

function initialize!(integrator, cache::FunctionMapCache)
    integrator.kshortsize = 0
    return resize!(integrator.k, integrator.kshortsize)
end

function perform_step!(integrator, cache::FunctionMapCache, repeat_step = false)
    (; u, uprev, dt, t, f, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; tmp) = cache
    return if integrator.f != DiffEqBase.DISCRETE_INPLACE_DEFAULT &&
            !(
            integrator.f isa DiffEqBase.EvalFunc &&
                integrator.f.f === DiffEqBase.DISCRETE_INPLACE_DEFAULT
        )
        if FunctionMap_scale_by_time(alg)
            f(tmp, uprev, p, t + dt)
            @muladd @.. broadcast = false u = uprev + dt * tmp
        else
            f(u, uprev, p, t + dt)
        end
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
end

function perform_step!(integrator, cache::FunctionMapConstantCache, repeat_step = false)
    (; uprev, dt, t, f, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    return if integrator.f != DiffEqBase.DISCRETE_OUTOFPLACE_DEFAULT &&
            !(
            integrator.f isa DiffEqBase.EvalFunc &&
                integrator.f.f === DiffEqBase.DISCRETE_OUTOFPLACE_DEFAULT
        )
        if FunctionMap_scale_by_time(alg)
            tmp = f(uprev, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            @muladd integrator.u = @.. broadcast = false uprev + dt * tmp
        else
            integrator.u = f(uprev, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
    end
end

function initialize!(integrator, cache::FunctionMapConstantCache)
    integrator.kshortsize = 0
    return integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
end
